#
# $Source: /home/nlfm/Working/Zircon/Released/installer/RCS/support.tcl,v $
# $Date: 1998/03/03 10:17:08 $
# $Revision: 1.18.1.20 $
#
# ----------------------------------------------------------------------
#   AUTHOR:  Lindsay Marshall <lindsay.marshall@newcastle.ac.uk>
# ----------------------------------------------------------------------
# Copyright 1996 The University of Newcastle upon Tyne (see COPYRIGHT)
# ======================================================================
#
package provide support 1.18
#
proc askUser {title msg} {
    global go
    if {$go} { return 1 }
    return [tk_dialog .ask $title $msg question 1 No Yes]
}
proc fail {msg} {
    tk_dialog .err Error! $msg error 0 OK
}
#
proc zinfo {msg} {
    .inst.info configure -text $msg
    update
}
#
proc Quit {} {
    exit
}
#
proc Go {} {
    catch {
        .inst configure -cursor {watch red}
        foreach x [winfo children .inst] {
	    catch {$x configure -cursor {watch red}}
	    catch {$x configure -state disabled}
        }
        .inst.btn.install configure -state disabled
    }
    if {[makeLibrary] && [makeBinary]} {
	zinfo Done!!
	if {[catch {open install.in w} fd]} {
	} {
	    foreach x {Type Lib Bin CC SCflag SLDflag CFlags Wish TIDir} {
		puts $fd "set $x {[uplevel #0 set $x]}"
	    }
	    close $fd
	}
    }
    catch {
	foreach x [winfo children .inst] {
	    catch {$x configure -state normal}
	    catch {$x configure -cursor arrow}
	}
	.inst.btn.install configure -state normal
	.inst configure -cursor arrow
    }
}
#
proc ncopy {file to} {
    if {![file exists [file join $to $file]]} { copy $file $to }
}
#
proc gridIt {w name row} {
    grid $w.$name -row $row -column 0 -sticky w -pady 2
    grid $w.${name}entry -sticky ew -row $row -column 1 -pady 2
}
#
proc fixPath {dir} {
    switch [file pathtype $dir] absolute {return $dir}
    return [file join [pwd] $dir]
}
#
#
proc copy {from to} {
    zinfo "Copying $from ..."
    set to [dmake [file dirname $from] $to]
    set target [file join $to [file tail $from]]
    copyfile $from $target
    mkReadable $target
}
#
proc dmake {from to} {
    switch . $from {} default {
	foreach x [file split $from] {
	    set to [file join $to $x]
	    filemkdir $to
	    mkReadable $to
	}
    }
    return $to
}
#
proc doGlobals {argv} {
    global Type types Lib Bin CC LD Version Patchlevel Wish types cflags\
      libs share SCflag GCC SLDflag CFlags TIDir Prefix ExecPrefix SED go
#
    source [file join installer zircon.tcl]
    set Type {}
    set Lib {}
    set Bin {}
    set CC {}
    set LD ld
    set GCC 1
    set SCflag {}
    set SLDflag {}
    set CFlags {}
    set Wish {}
    set TIDir {}
    set go 0
    set SED 0
    set Prefix {}
    set ExecPrefix {}
#
    while {![string match {} $argv]} {
	set v [lindex $argv 1]
	switch -glob -- [lindex $argv 0] {
	-b {set Bin $v }
	-c {set CC $v}
	-d {set LD $v}
	-e {set SED 1}
	-f {set CFlags $v}
	-g {set go 1 ; set argv [lrange $argv 1 end] ; continue }
	-h {set TIDir $v}
	-l {set Lib $v }
	-s {set SCflag $v}
	-t {set Type $v }
	-w {set Wish $v}
	-z {set SLDflag $v }
	--prefix=* {  regexp {--prefix=(.*)} $v m ExecPrefix; set go 1}
	--exec_prefix=* { regexp {--exec_prefix=(.*)} $v m ExecPrefix ; set go 1}
	--wish=* { regexp {--wish=(.*)} $v m Wish ; set go 1 }
	}
	set argv [lrange $argv 2 end]
    }
    catch {source install.in}
    return argv
}
#
proc mainWindow {} {
    global Version Patchlevel NoGUI
    if {$NoGUI} { return {} }
    set w [toplevel .inst]
    wm title $w {Zircon Installer}
    wm resizable $w 1 0 
    grid columnconfigure $w 1 -weight 1
    frame $w.vinfo -relief groove -borderwidth 3
    set img [image create photo -file gifs/zlogo.gif]
    label $w.vinfo.vlogo -image $img -relief groove -borderwidth 3
    label $w.vinfo.version -text Zircon
    label $w.vinfo.patch -text "Version $Version Patchlevel $Patchlevel"
    grid columnconfigure $w.vinfo 0 -weight 1
    grid $w.vinfo.version -sticky ew -row 0 -column 0
    grid $w.vinfo.patch -sticky ew -row 1 -column 0
    grid $w.vinfo.vlogo -sticky e -row 0 -column 1 -rowspan 2
    grid $w.vinfo - -sticky ew
    grid [frame $w.sep1 -bg red] - -sticky ew -pady 2
    return $w
}
#
proc makeEntry {w wn txt var row cmd} {
    global NoGUI
    if {!$NoGUI} {
        button $w.$wn -text $txt
	entry $w.${wn}entry -textvariable $var
    }
    $cmd
    if {!$NoGUI} { gridIt $w $wn $row }
}
#
proc Null {} { }



